<template>
  <rui-navbar :caption="pageTitle" v-bind="backLink">
    <template #left>
      <rui-menu-item :to="{name: 'home'}" icon="home" :title="$t('js.layouts.garden.main_menu.home')" />
    </template>

    <template #right>
      <gp-theme-switcher-menu-item />
      <rui-menu-item icon="notification"
                     :title="$t('js.layouts.garden.main_menu.notifications')"
                     :variant="unreadNotificationCount > 0 ? 'helper' : null"
                     @click="$emitBus('show-notifications')">
        {{ unreadNotificationCount }}
      </rui-menu-item>
    </template>
  </rui-navbar>
</template>

<script>
import RuiMenuItem from '@experiments-labs/rise_ui/src/components/Menu/MenuItem.vue'
import RuiNavbar from '@experiments-labs/rise_ui/src/components/Navbar/Navbar.vue'
import GpThemeSwitcherMenuItem from '../../../../common/ThemeSwitcherMenuItem.vue'

export default {
  name: 'GpaMainMenu',
  components: { GpThemeSwitcherMenuItem, RuiNavbar, RuiMenuItem },
  data () {
    return {
      currentMapId: null,
    }
  },
  computed: {
    currentMap () { return this.$store.getters.map(this.currentMapId) },
    showMapLink () { return this.currentMap && !this.$route.meta.inMap },
    inGarden () { return this.currentMap && this.$route.meta.inMap },
    unreadNotificationCount () { return this.$store.getters.unreadNotification.length },
    backLink () {
      if (!this.showMapLink) return {}

      return {
        backTo: { name: 'map', params: { mapId: this.currentMap.id } },
        backCaption: this.$t('js.layouts.garden.main_menu.back_to', { name: this.currentMap.name }),
      }
    },
    pageTitle () {
      // Router not ready
      if (!this.$route.name) return ''

      if (this.$route.meta?.inMap) {
        return this.currentMap?.name || ''
      }

      if (!this.$route.meta.title) throw new Error(`Unhandled route ${this.$route.name}`)

      return this.$route.meta.title
    },
  },
  methods: {
    setCurrentMap (id) {
      if (id) localStorage.setItem('currentMap', id)

      const savedId = id || localStorage.getItem('currentMap')

      if (!savedId) {
        this.currentMapId = null
        return
      }

      this.currentMapId = parseInt(savedId, 10)
    },
    updatePageTitle () {
      const suffix = ' | Garden Party'
      let mapName = ''
      if (this.inGarden) mapName = ` | ${this.currentMap.name}`

      document.querySelector('head > title').innerText = `${this.$route.meta.title}${mapName}${suffix}`
    },
  },
  created () {
    this.setCurrentMap(this.$route.params?.mapId)
    this.updatePageTitle()
  },
  watch: {
    '$route.params.mapId' (newValue) {
      this.setCurrentMap(newValue)
    },
    '$route.name' () {
      this.updatePageTitle()
    },
  },
}
</script>
